package com.flow.flowable.behavior;

import com.flow.flowable.cmd.JumpActivityCmd;
import com.flow.flowable.model.JumpServiceTask;
import org.flowable.common.engine.api.delegate.Expression;
import org.flowable.common.engine.impl.el.ExpressionManager;
import org.flowable.engine.ManagementService;
import org.flowable.engine.delegate.DelegateExecution;
import org.flowable.engine.impl.bpmn.behavior.AbstractBpmnActivityBehavior;
import org.flowable.engine.impl.util.CommandContextUtil;
import org.springframework.util.StringUtils;

public class JumpActivityBehavior extends AbstractBpmnActivityBehavior {

    @Override
    public void execute(DelegateExecution execution) {
        JumpServiceTask jumpServiceTask = (JumpServiceTask) execution.getCurrentFlowElement();
        String skipExpression = jumpServiceTask.getSkipExpression();
        if (!StringUtils.isEmpty(skipExpression)) {
            ExpressionManager expressionManager = CommandContextUtil.getProcessEngineConfiguration().getExpressionManager();
            Expression expression = expressionManager.createExpression(skipExpression);
            Object result = expression.getValue(execution);
            if ((result instanceof Boolean && (Boolean) result)) {
                leave(execution);
                return;
            }
        }
        ManagementService managementService = CommandContextUtil.getProcessEngineConfiguration().getManagementService();
        managementService.executeCommand(new JumpActivityCmd(execution.getProcessInstanceId(), jumpServiceTask.getTargetNode()));
        leave(execution);
    }
}
